SystemOrganization addCategory: #ConfigurationOfFSGit!

Object subclass: #ConfigurationOfFSGit
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFSGit'!

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'MaxLeske 3/21/2011 19:29'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFSGit class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:29'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
compareVersions
	"Compare the #stable version to #development version"

	"self compareVersions"

	<apiDocumentation>
	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) compareVersionsIn: self) inspect
! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
createNewBaselineVersion
	"Create a new baseline version based upon the #stable version's baseline.
	 A new baseline should be created if new packages have been added or package dependencies have changed."

	"self createNewDevelopmentVersion"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) createNewBaselineVersionIn: self description: ''
! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
createNewDevelopmentVersion
	"Create a new development version using the #stable version as model."

	"self createNewDevelopmentVersion"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) createNewDevelopmentVersionIn: self description: ''! !

!ConfigurationOfFSGit class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:29'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFSGit class methodsFor: 'private' stamp: 'MaxLeske 3/21/2011 19:29'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFSGit class methodsFor: 'metacello tool support' stamp: 'MaxLeske 3/21/2011 19:29'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFSGit class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:29'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFSGit class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:29'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFSGit class methodsFor: 'loading' stamp: 'MaxLeske 3/21/2011 19:29'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFSGit class methodsFor: 'accessing' stamp: 'MaxLeske 3/21/2011 19:29'!
project

	^self new project! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
releaseDevelopmentVersion: commitMessage
	"Release #development version: set version blessing to #release, update the #development and #stable symbolic version methods and save the configuration."

	"self releaseDevelopmentVersion: '- release version 1.0.2'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) releaseDevelopmentVersionIn: self description: commitMessage! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
saveConfiguration: commitMessage
	"Save mcz file that contains the configuration to it's repository."

	"self saveConfiguration: '- fixed bug'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) saveConfigurationPackageFor: self name asString description: commitMessage! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
saveModifiedPackagesAndConfiguration: commitMessage
	"Save modified mcz files, update the #development version and then save the configuration."

	"self saveModifiedPackagesAndConfiguration: '- fixed bug'"

	<apiDocumentation>
	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) saveModifiedPackagesAndConfigurationIn: self description: commitMessage! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'CamilloBruni 1/24/2012 11:01'!
updateToLatestPackageVersions: descriptionString
	"Update the #development version to match currently loaded mcz files."

	"self updateToLatestPackageVersions: '- fixed a bug'"

	<apiDocumentation>
	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) updateToLatestPackageVersionsIn: self description: descriptionString) isEmpty
		ifTrue: [ self inform: 'All specs up to date' ]! !

!ConfigurationOfFSGit class methodsFor: 'development support' stamp: 'MaxLeske 3/21/2011 19:29'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFSGit methodsFor: 'baselines' stamp: 'CamilloBruni 1/24/2012 11:06'!
baseline100: spec
	<version: '1.0.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/GitFS'.
		spec 
			package: 'FS-Git' with: [
				spec requires: #('Filesystem' ). ];
			package: 'Filesystem'.
		spec group: 'default' with: #('FS-Git' ). ].
! !

!ConfigurationOfFSGit methodsFor: 'baselines' stamp: 'CamilloBruni 1/24/2012 11:06'!
baseline200: spec
	<version: '2.0.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec 
			package: 'FS-Git';
			group: 'default' with: #('FS-Git' ). ].
! !

!ConfigurationOfFSGit methodsFor: 'baselines' stamp: 'CamilloBruni 1/24/2012 11:06'!
baseline210: spec
	<version: '2.1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: 'Filesystem' with: [
			spec
				className: 'ConfigurationOfFilesystem';
				loads: 'default';
				repository: 'http://www.squeaksource.com/fs' ].
		spec 
			package: 'FS-Git' with: [ spec requires: #('Filesystem') ];
			group: 'default' with: #('FS-Git' ). ].
! !

!ConfigurationOfFSGit methodsFor: 'baselines' stamp: 'CamilloBruni 1/24/2012 11:06'!
baseline222: spec
	<version: '2.2.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		
		spec project: 'Filesystem' with: [
			spec
				className: 'ConfigurationOfFilesystem';
				loads: 'default';
				repository: 'http://www.squeaksource.com/fs' ].
		
		spec project: 'Autotest' with: [
			spec
				className: 'ConfigurationOfAutotest';
				versionString: '1.2';
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		
		spec 
			package: 'FS-Git' with: [ spec requires: #('Filesystem') ];
			group: 'default' with: #('FS-Git' );
			group: 'dev' with: #('FS-Git' 'Autotest') ].
! !

!ConfigurationOfFSGit methodsFor: 'baselines' stamp: 'dkh 2/1/2012 12:46'!
baseline225: spec
	<version: '2.2.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		
		spec project: 'Filesystem' with: [
			spec
				className: 'ConfigurationOfFilesystem';
				version: #development;
				repository: 'http://www.squeaksource.com/fs' ].
			
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				version: #stable;
				repository: 'http://www.squeaksource.com/MetacelloRepository'].

		spec 
			package: 'FS-Git' with: [ 
				spec requires: #('Filesystem' 'OSProcess') ];
			group: 'default' with: #('FS-Git' );
			group: 'dev' with: #('FS-Git' ) ].
! !

!ConfigurationOfFSGit methodsFor: 'symbolic versions' stamp: 'MaxLeske 8/25/2011 18:46'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '2.2.4'.

	spec for: #'pharo1.2.x' version: #'bleedingEdge'.

	spec for: #'pharo1.3.x' version: #'bleedingEdge'.

	spec for: #'pharo1.4.x' version: #'bleedingEdge'.

	spec for: #'pharo1.x.x' version: #'notDefined'.

	spec for: #'squeak' version: #'notDefined'.
! !

!ConfigurationOfFSGit methodsFor: 'accessing' stamp: 'MaxLeske 3/21/2011 19:29'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFSGit methodsFor: 'symbolic versions' stamp: 'MaxLeske 8/14/2011 22:14'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo1.x.x' version: '1.2'.
	spec for: #'common' version: '2.2.3'.
	spec for: #'squeak' version: #notDefined! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version100: spec
	<version: '1.0.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'initial version'.
		spec author: 'MaxLeske'.
		spec timestamp: '3/21/2011 19:30'.
		spec 
			package: 'FS-Git' with: 'FS-Git-MaxLeske.99';
			package: 'Filesystem' with: 'Filesystem-MaxLeske.91'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:06'!
version110: spec
	<version: '1.1.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'fixes for Pharo 1.2 (Cog)'.
		spec author: 'MaxLeske'.
		spec timestamp: '5/25/2011 19:30'.
		spec 
			package: 'FS-Git' with: 'FS-Git-MaxLeske.103';
			package: 'Filesystem' with: 'Filesystem-MaxLeske.92'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:06'!
version120: spec
	<version: '1.2.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'fixes for Pharo 1.2 (Cog)'.
		spec author: 'MaxLeske'.
		spec timestamp: '7/16/2011 09:30'.
		spec 
			package: 'FS-Git' with: 'FS-Git-MaxLeske.122';
			package: 'Filesystem' with: 'Filesystem-CamilloBruni.98'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version210: spec
	<version: '2.1.0' imports: #('2.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'Adapted for new Filesystem implementation'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/3/2011 11:00'.
		spec project: #Filesystem with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-MaxLeske.135' ]
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version211: spec
	<version: '2.1.1' imports: #('2.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'Adapted for new Filesystem implementation'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/3/2011 11:00'.
		spec project: #Filesystem with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-MaxLeske.136' ]
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version212: spec
	<version: '2.1.2' imports: #('2.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'Fixed last failing tests'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/4/2011 17:48'.
		spec project: #Filesystem with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-CamilloBruni.137' ]
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version220: spec
	<version: '2.2.0' imports: #('2.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec description: 'Fixed GitFSCK. All tests green.'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/8/2011 19:56'.
		spec project: #Filesystem with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-CamilloBruni.139' ]
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version221: spec
	<version: '2.2.1' imports: #('2.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'updates for Monticello support'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/9/2011 18:09'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: #Filesystem with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-CamilloBruni.140'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version222: spec
	<version: '2.2.2' imports: #('2.2.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'fixes to FSGit; development on Monticello support
Exception hierarchy and several fixes
* implemented support for packed tags
* added test for packed tags
* some refactoring / renaming
* fix: #isHeadless is not understood by Pharo < 1.3
* a bit of cleaning up'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/12/2011 10:09'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: 'Filesystem' with: '2.0.1'.
		spec package: 'FS-Git' with: 'FS-Git-MaxLeske.146'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version223: spec
	<version: '2.2.3' imports: #('2.2.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '* added first simple help pages
* added FSFilesystem class>>onGit: for compliance
* updated help'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/15/2011 11:20'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: 'Filesystem' with: '2.0.2'.
		spec package: 'FS-Git' with: 'FS-Git-MaxLeske.149'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:05'!
version224: spec
	<version: '2.2.4' imports: #('2.2.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '* updated help
* categorized methods'.
		spec author: 'MaxLeske'.
		spec timestamp: '8/25/2011 19:44'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: 'Filesystem' with: '2.0.3'.
		spec package: 'FS-Git' with: 'FS-Git-MaxLeske.158'. ].
! !

!ConfigurationOfFSGit methodsFor: 'versions' stamp: 'CamilloBruni 1/24/2012 11:04'!
version225: spec
	<version: '2.2.5' imports: #('2.2.5-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'added basic support for git / monticello'.
		spec author: 'Camillo Bruni'.
		spec timestamp: '8/25/2011 19:44'.
		spec repository: 'http://www.squeaksource.com/FSGit'.
		spec project: 'Filesystem' with: '2.0.3'.
		spec package: 'FS-Git' with: 'FS-Git-CamilloBruni.166'. ].
! !
